C
C  Program : FRAMDENS
C      Open a multiple .cif (concatenated)
C        calculates the framework densities (FD)
C        (FD = number of cations for V = 1000 A**3) 
C        provides the classification by 
C        increasing FD order
C
C
C   Armel Le Bail (alb@cristal.org) - March 2006
C
C
      program main
      parameter (ngood=10000)
      character fname*20,fname1*20,infile*20,text*80,p*1
      character*50 textd
      character*20 volume
      character*7 texta
      character*44 pcod(ngood)
      character*35 textb
      real vol(ngood),fd(ngood)
      integer ll(ngood)
      logical lexist
      write
     1(*,'('' Enter name of multiple CIF (no extension) :'',$)')
      read (*,'(a)')fname1
C ---- now open files
      ilen=leng(fname1)
      infile=fname1(1:ilen)//'.cif'
      open (25,file=infile,status='unknown')
      fname=fname1(1:ilen)//'.out'
      open (26,file=fname,status='new')
C
C Loop on the multiple CIF file
C
       igood=0
1      read(25,'(a)',end=6)text
       igood=igood+1
       ik=1
2     read(25,'(a)')text
       ik=ik+1
      if(ik.eq.5)pcod(igood)=text(1:44)
C
C     finding the volume
C
        if(text(1:17).eq.'_cell_angle_gamma')then
          read(25,'(a20,f9.2)')volume,vol(igood)
          nat=0
49        read(25,'(a)')text
        if(text(1:18).ne.'_atom_site_fract_z')go to 49
C  atom
50         read(25,'(a)')text
          if(text(1:1).ne.'O')then
          nat=nat+1
          go to 50
          endif
          fd(igood)=float(nat)/vol(igood)*1000.
        endif

C
C     finding # PCOD
C
        if(text(1:6).eq.'# PCOD')then
C
         read(25,3)p,ii
3     format(a1,I5)
4     format(I3)        
7     format(a78)        
         read(25,'(a)')text
         do 5 i=1,ii
         read(25,'(a)')text
5        continue
C last lines with #
         read(25,'(a)')text
         read(25,'(a)')text
         read(25,'(a)')text
C
         go to 1
         endif


         go to 2
6     continue
C
C End of loop
C
      close (25)
C
C  Now order...
C
      CALL SORT(IGOOD,FD,LL)
      write(26,*)
      WRITE(26,*)'  Models ordered according to FD'
      DO I=1,IGOOD
      ii=LL(I)
      write(26,'(a44,2F9.2)')pcod(ii),vol(ii),fd(ii)
      enddo
C
C
      close(26)
      WRITE(*,3955)
3955  FORMAT(//'  Type any character and a RETURN to continue : ',$)
      READ(*,*)FEND
      stop
      end
*
********************************************************* 
*
      SUBROUTINE SORT(N,A,L)
C     ********************************************************
C     THE SUBROUTINE SORT APPLIES TO THE ARRAY A WITH J ELEMENTS.
C     THE INDICES OF THE ORDERED ARRAY ARE PLACED IN ARRAY L
C     TO OBTAIN THE ORDERED ARRAY REPLACE THE INDICES I OF A(I)
C     WITH I=L(I)---REF.CACM 271
C     *********************************************************
C
      PARAMETER(NGOOD=10000)
      DIMENSION IUT(10),ILT(10)
      DIMENSION A(NGOOD),L(NGOOD)
      J=N
      I=1
      M=1
      DO 10 K=1,J
10    L(K)=K
20    IF(J-I-1)140,140,30
30    IP=(J+I)/2
      ITT=L(IP)
      T=A(ITT)
      L(IP)=L(I)
      IQ=J
      K=I+1
40    IF(K.GT.IQ)GOTO 90
      LK=L(K)
      IF(A(LK).LE.T)GOTO 80
      IQ=IQ
50    IF(IQ.LT.K)GOTO 70
      LQ=L(IQ)
      IF(A(LQ).GE.T)GOTO 60
      IX=L(K)
      L(K)=L(IQ)
      L(IQ)=IX
      IQ=IQ-1
      GOTO 80
60    IQ=IQ-1
      GOTO 50
70    CONTINUE
      IQ=K-1
      GOTO 100
80    K=K+1
      GOTO 40
90    CONTINUE
100   L(I)=L(IQ)
      L(IQ)=ITT
      IF(2*IQ-I-J)120,120,110
110   ILT(M)=I
      IUT(M)=IQ-1
      I=IQ+1
      GOTO 130
120   ILT(M)=IQ+1
      IUT(M)=J
      J=IQ-1
130   M=M+1
      GOTO 20
140   IF(I-J)150,170,170
150   LI=L(I)
      LJ=L(J)
      IF(A(LI)-A(LJ))170,170,160
160   IX=L(I)
      L(I)=L(J)
      L(J)=IX
170   M=M-1
      IF(M)190,190,180
180   I=ILT(M)
      J=IUT(M)
      GOTO 20
190   CONTINUE
      RETURN
      END
*
*
*-----------------------------------------------------------------------
      integer function leng(string)
C     returns significant length of  'string'
      character*(*)string
      do 1 leng=len(string),0,-1
1        if (string(leng:leng) .ne. ' ') goto 2
2     end
C
C----------------------------------------------------------------------C
